/* BMP16.H - 1-bit and 4-bit BMP manipulation routines - header file.
**
** Copyright (c)2007 by Ignacio R. Morelle "Shadow Master". (shadowm2006@gmail.com)
** Original code Copyright (c)2002-2004 Andrew Durdin. (andy@durdin.net)
** FIN2BMP compatibility code added by Ignacio R. Morelle "Shadow Master"
** (shadowm2006@gmail.com), the code is Copyright (c)2002 Andrew Durdin
**
** This software is provided 'as-is', without any express or implied warranty.
** In no event will the authors be held liable for any damages arising from
** the use of this software.
** Permission is granted to anyone to use this software for any purpose, including
** commercial applications, and to alter it and redistribute it freely, subject
** to the following restrictions:
**    1. The origin of this software must not be misrepresented; you must not
**       claim that you wrote the original software. If you use this software in
**       a product, an acknowledgment in the product documentation would be
**       appreciated but is not required.
**    2. Altered source versions must be plainly marked as such, and must not be
**       misrepresented as being the original software.
**    3. This notice may not be removed or altered from any source distribution.
*/

#ifndef INC_BMP16_H__
#define INC_BMP16_H__

struct BITMAP16
{
    unsigned int width;
    unsigned int height;
    unsigned long linewidth;    /* width of line in bytes (includes padding) */
    unsigned int bpp;
    unsigned int colours;
    unsigned char **lines;
    unsigned char *bits;
};
typedef struct BITMAP16 BITMAP16;

void bmp_free(BITMAP16 *bmp);
BITMAP16 *bmp_create(int width, int height, int bpp);
BITMAP16 *bmp_load(char *fname);
int bmp_save(BITMAP16 *bmp, char *fname, int backup);
int bmp_putpixel(BITMAP16 *bmp, int x, int y, int c);
int bmp_getpixel(BITMAP16 *bmp, int x, int y);
void bmp_rect(BITMAP16 *bmp, int x1, int y1, int x2, int y2, int c);
BITMAP16 *bmp_duplicate(BITMAP16 *bmp);
int bmp_split(BITMAP16 *bmp, BITMAP16 **red, BITMAP16 **green, BITMAP16 **blue, BITMAP16 **bright);
BITMAP16 *bmp_merge(BITMAP16 *red, BITMAP16 *green, BITMAP16 *blue, BITMAP16 *bright);
void bmp_blit(BITMAP16 *src, unsigned int srcx, unsigned int srcy, BITMAP16 *dest, unsigned int destx, unsigned int desty, unsigned int width, unsigned int height);

void bmp_unpack( BITMAP16 *bmp );

#endif /* !INC_BMP16_H__ */
